import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

public class CommercialVehicle
    extends OffRoadVehicle
{
    public static final String ORACLE_OBJECT_NAME = "COMMERCIAL_VEHICLE_OBJ_T";

    protected Odometer maintenanceOdometer;

    public CommercialVehicle()
    {
        setSQLTypeName(ORACLE_OBJECT_NAME);
    }

    public boolean maintenanceRequired()
    {
        return maintenanceOdometer.getMileage() > 1000;
    }

    protected void readSQL(SQLInput sqlInput)
        throws SQLException
    {
        super.readSQL(sqlInput);

        maintenanceOdometer = (Odometer)sqlInput.readObject();
    }

    public void readSQL(SQLInput sqlInput, String sqlTypeName)
        throws SQLException
    {
        setSQLTypeName(sqlTypeName);
        readSQL(sqlInput);
    }

    public void writeSQL(SQLOutput sqlOutput)
        throws SQLException
    {
        super.writeSQL(sqlOutput);
        sqlOutput.writeObject(maintenanceOdometer);
    } 

    protected String attributeString()
    {
        StringBuffer retVal = new StringBuffer(128);

        retVal.append(super.attributeString());
        retVal.append("  Commercial Vehicle attributes:\n");
        retVal.append("    maintenance odometer: ").append(maintenanceOdometer).append("\n");

        return retVal.toString();
    }

    public String toString()
    {
        StringBuffer retVal = new StringBuffer(128);

        retVal.append("CommercialVehicle:\n");
        retVal.append(attributeString());

        return retVal.toString();
    }
}
