import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

public class FuelTank
    extends AbstractSQLData
{
    public static final String ORACLE_OBJECT_NAME = "FUEL_TANK_OBJ_T";

    private int fuelTankId;
    private int capacity;
    
    public FuelTank()
    {
        setSQLTypeName(ORACLE_OBJECT_NAME);
    }

    public int range(int mpg)
    {
        return (capacity * mpg);
    }

    public void readSQL(SQLInput sqlInput, String sqlTypeName)
        throws SQLException
    {
        setSQLTypeName(sqlTypeName);

        fuelTankId = sqlInput.readInt();
        capacity = sqlInput.readInt();
    }

    public void writeSQL(SQLOutput sqlOutput)
        throws SQLException
    {
        sqlOutput.writeInt(fuelTankId);
        sqlOutput.writeInt(capacity);
    } 

    public String toString()
    {
        return Integer.toString(capacity) + " gallons";
    }
}
