prompt Deleting tables FUEL_TANK, ODOMETER and VEHICLE...

drop table FUEL_TANK;
drop table ODOMETER;
drop table VEHICLE;

commit;

prompt Creating tables FUEL_TANK, ODOMETER and VEHICLE...

create table FUEL_TANK
(
  FUEL_TANK_ID NUMBER(10) not null,
  CAPACITY     NUMBER(2) not null
);

alter table FUEL_TANK add constraint PK_FUEL_TANK_ID primary key (FUEL_TANK_ID);

create table ODOMETER
(
  ODOMETER_ID NUMBER(10) not null,
  MILEAGE     NUMBER(8) not null
);

alter table ODOMETER add constraint PK_ODOMETER_ID primary key (ODOMETER_ID);

create table VEHICLE
(
  VEHICLE_ID              NUMBER(10) not null,
  MAKE                    VARCHAR2(80) not null,
  MODEL                   VARCHAR2(80) not null,
  ODOMETER_ID             NUMBER(10) not null,
  TRIP_ODOMETER_ID        NUMBER(10) not null,
  FUEL_TANK_ID            NUMBER(10) not null,
  AUXILLARY_FUEL_TANK_ID  NUMBER(10),
  MAINTENANCE_ODOMETER_ID NUMBER(10),
  MPG                     NUMBER(2) not null
);

alter table VEHICLE add constraint PK_VEHICLE_ID primary key (VEHICLE_ID);

commit;

prompt Loading FUEL_TANK...

insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (1, 18);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (2, 16);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (3, 15);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (4, 10);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (5, 18);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (6, 12);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (7, 50);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (8, 50);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (9, 17);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (10, 19);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (11, 20);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (12, 15);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (13, 18);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (14, 12);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (15, 48);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (16, 48);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (17, 14);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (18, 18);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (19, 15);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (20, 12);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (21, 18);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (22, 12);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (23, 55);
insert into FUEL_TANK (FUEL_TANK_ID, CAPACITY) values (24, 55);

commit;

prompt Loading ODOMETER...

insert into ODOMETER (ODOMETER_ID, MILEAGE) values (1, 40000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (2, 100);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (3, 50000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (4, 125);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (5, 60000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (6, 150);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (7, 70000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (8, 175);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (9, 80000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (10, 200);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (11, 1150);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (12, 75000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (13, 225);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (14, 65000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (15, 250);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (16, 55000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (17, 215);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (18, 45000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (19, 185);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (20, 35000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (21, 135);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (22, 2150);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (23, 17000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (24, 95);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (25, 22000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (26, 120);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (27, 27000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (28, 170);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (29, 32000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (30, 220);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (31, 37000);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (32, 270);
insert into ODOMETER (ODOMETER_ID, MILEAGE) values (33, 1975);

commit;

prompt Loading VEHICLE...

insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (1, 'Ford', 'Scorpio', 1, 2, 1, null, null, 24);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (2, 'Ford', 'Trotter', 3, 4, 2, null, null, 25);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (3, 'Ford', 'Adventurer', 5, 6, 3, 4, null, 17);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (4, 'Ford', 'Enterprise', 7, 8, 5, 6, null, 16);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (5, 'Ford', 'G-780', 9, 10, 7, 8, 11, 12);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (6, 'Dodge', 'Ballsy', 12, 13, 9, null, null, 26);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (7, 'Dodge', 'Adder', 14, 15, 10, null, null, 24);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (8, 'Dodge', 'Cebolla', 16, 17, 11, 12, null, 16);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (9, 'Dodge', 'Montanna', 18, 19, 13, 14, null, 15);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (10, 'Dodge', 'Hammer 3800', 20, 21, 15, 16, 22, 12);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (11, 'Chevrolet', 'Insolent', 23, 24, 17, null, null, 26);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (12, 'Chevrolet', 'Destroyer', 25, 26, 18, null, null, 22);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (13, 'Chevrolet', 'Reno', 27, 28, 19, 20, null, 14);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (14, 'Chevrolet', 'Cossack', 29, 30, 21, 22, null, 16);
insert into VEHICLE (VEHICLE_ID, MAKE, MODEL, ODOMETER_ID, TRIP_ODOMETER_ID, FUEL_TANK_ID, AUXILLARY_FUEL_TANK_ID, MAINTENANCE_ODOMETER_ID, MPG) values (15, 'Chevrolet', 'Backwoods', 31, 32, 23, 24, 33, 10);

commit;

prompt Removing Packages/Types...

drop package body vehicle_manager;
drop package vehicle_manager;
drop type vehicle_info_tbl_t;
drop type body vehicle_info_obj_t;
drop type vehicle_info_obj_t;
drop type body commercial_vehicle_obj_t;
drop type commercial_vehicle_obj_t;
drop type body offroad_vehicle_obj_t;
drop type offroad_vehicle_obj_t;
drop type body passenger_vehicle_obj_t;
drop type passenger_vehicle_obj_t;
drop type vehicle_tbl_t;
drop type body vehicle_obj_t;
drop type vehicle_obj_t;
drop type odometer_tbl_t;
drop type odometer_obj_t;
drop type fuel_tank_tbl_t;
drop type fuel_tank_obj_t;
drop type make_tbl_t;

prompt Creating Packages/Types...

create or replace type make_tbl_t as table of varchar2(80)
/

create or replace type fuel_tank_obj_t as object
(
  fuel_tank_id number(10),
  capacity number(3)
)
/

create or replace type fuel_tank_tbl_t as table of fuel_tank_obj_t
/

create or replace type odometer_obj_t as object
(
  odometer_id number(10),
  mileage number(8)
)
/

create or replace type odometer_tbl_t as table of odometer_obj_t
/

create or replace type vehicle_obj_t as object
(
  vehicle_id number(10),
  make varchar2(80),
  model varchar2(80),
  range number(4),
  fuel_tank fuel_tank_obj_t,
  odometer odometer_obj_t,
  trip_odometer odometer_obj_t,
  
  member procedure set_range(mpg in number),
  member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t)
) not instantiable not final
/

create or replace type body vehicle_obj_t is
  
  member procedure set_range(mpg in number) is
  begin

     range := mpg * fuel_tank.capacity;

  end;

  member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t) is
  begin
  
    self.vehicle_id := vehicle_id;
    self.make := make;
    self.model := model;
    self.odometer := odometer;
    self.trip_odometer := trip_odometer;
    self.fuel_tank := fuel_tank;
    
  end;
  
end;
/

create or replace type vehicle_tbl_t as table of vehicle_obj_t
/

create or replace type passenger_vehicle_obj_t under vehicle_obj_t
(
  constructor function passenger_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t) return self as result
) not final
/

create or replace type body passenger_vehicle_obj_t is
  
  constructor function passenger_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t) return self as result is
  begin

    self.set_attributes(vehicle_id, make, model, odometer, trip_odometer, fuel_tank); 
    self.set_range(mpg);
    
    return;
    
  end;  
  
end;
/

create or replace type offroad_vehicle_obj_t under passenger_vehicle_obj_t
(
  auxillary_fuel_tank fuel_tank_obj_t,
 
  overriding member procedure set_range(mpg in number),
  member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t),
  constructor function offroad_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) return self as result

) not final
/

create or replace type body offroad_vehicle_obj_t is
  
  overriding member procedure set_range(mpg in number) is
  begin
  
     range := mpg * (fuel_tank.capacity + auxillary_fuel_tank.capacity);
     
  end;
  
  member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) is
  begin
    
    self.set_attributes(vehicle_id, make, model, odometer, trip_odometer, fuel_tank);
    self.auxillary_fuel_tank := auxillary_fuel_tank;
  
  end;  
  
  constructor function offroad_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) return self as result is
  begin
    
    set_attributes(vehicle_id, make, model, odometer, trip_odometer, fuel_tank, auxillary_fuel_tank);
    set_range(mpg);
    
    return;
    
  end;  
  
end;
/

create or replace type commercial_vehicle_obj_t under offroad_vehicle_obj_t
(
  maintenance_odometer odometer_obj_t, 
  
   member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, maintenance_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t),
   constructor function commercial_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, maintenance_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) return self as result
   
) not final
/

create or replace type body commercial_vehicle_obj_t is
  
  member procedure set_attributes(vehicle_id in number, make in varchar2, model in varchar2, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, maintenance_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) is
  begin
  
    self.set_attributes(vehicle_id, make, model, odometer, trip_odometer, fuel_tank, auxillary_fuel_tank);
    self.maintenance_odometer := maintenance_odometer;
    
  end;
  
  constructor function commercial_vehicle_obj_t(vehicle_id in number, make in varchar2, model in varchar2, mpg in number, odometer in odometer_obj_t, trip_odometer in odometer_obj_t, maintenance_odometer in odometer_obj_t, fuel_tank in fuel_tank_obj_t, auxillary_fuel_tank in fuel_tank_obj_t) return self as result is
  begin
    
    set_attributes(vehicle_id, make, model, odometer, trip_odometer, maintenance_odometer, fuel_tank, auxillary_fuel_tank);
    self.set_range(mpg);
    
    return;
    
  end;  
  
end;
/

create or replace type vehicle_info_obj_t as object
(
  vehicle_id number(10),
  make varchar2(80),
  model varchar2(80),
  mpg number(2),
  fuel_tank fuel_tank_tbl_t,
  auxillary_fuel_tank fuel_tank_tbl_t,
  odometer odometer_tbl_t,
  trip_odometer odometer_tbl_t,
  maintenance_odometer odometer_tbl_t,
  
  member function get_vehicle return vehicle_obj_t
)
/

create or replace type body vehicle_info_obj_t is
  
  member function get_vehicle return vehicle_obj_t is
  
    vehicle_obj vehicle_obj_t;
  
  begin
    
    if maintenance_odometer.count = 1 then
      
      vehicle_obj := commercial_vehicle_obj_t(vehicle_id, make, model, mpg, odometer(1), trip_odometer(1), maintenance_odometer(1), fuel_tank(1), auxillary_fuel_tank(1));
      
    else 
    
      if auxillary_fuel_tank.count = 1 then
    
        vehicle_obj := offroad_vehicle_obj_t(vehicle_id, make, model, mpg, odometer(1), trip_odometer(1), fuel_tank(1), auxillary_fuel_tank(1));
    
      else 
    
        vehicle_obj := passenger_vehicle_obj_t(vehicle_id, make, model, mpg, odometer(1), trip_odometer(1), fuel_tank(1));
      
      end if;
      
    end if;
    
    return vehicle_obj;
    
  end;
  
end;
/

create or replace type vehicle_info_tbl_t as table of vehicle_info_obj_t
/

create or replace package vehicle_manager is

  function search(make_tbl in make_tbl_t) return vehicle_tbl_t;

end vehicle_manager;
/

create or replace package body vehicle_manager is

  type ref_cur_t is ref cursor;
  
  function search(make_tbl in make_tbl_t) return vehicle_tbl_t is
  
    vehicle_info_cur ref_cur_t;
    vehicle_info_tbl vehicle_info_tbl_t;
  
    vehicles vehicle_tbl_t := vehicle_tbl_t();
  
  begin
    
    open vehicle_info_cur for select cast ( multiset ( 
      select v.vehicle_id
           , v.make
           , v.model
           , v.mpg
           , cast ( multiset ( 
               select ft.fuel_tank_id, ft.capacity from fuel_tank ft where v.fuel_tank_id = ft.fuel_tank_id 
             ) as fuel_tank_tbl_t )
           , cast ( multiset ( 
               select ft.fuel_tank_id, ft.capacity from fuel_tank ft where v.auxillary_fuel_tank_id = ft.fuel_tank_id 
             ) as fuel_tank_tbl_t )
           , cast ( multiset ( 
               select o.odometer_id, o.mileage from odometer o where v.odometer_id = o.odometer_id 
             ) as odometer_tbl_t ) 
           , cast ( multiset ( 
               select o.odometer_id, o.mileage from odometer o where v.trip_odometer_id = o.odometer_id 
             ) as odometer_tbl_t )
           , cast ( multiset ( 
               select o.odometer_id, o.mileage from odometer o where v.maintenance_odometer_id = o.odometer_id 
             ) as odometer_tbl_t )
        from vehicle v where make in (select * from table ( make_tbl ) )
    ) as vehicle_info_tbl_t ) from dual;
    
    if vehicle_info_cur%isopen then
    
      fetch vehicle_info_cur into vehicle_info_tbl;
      
      if vehicle_info_tbl.count > 0 then
      
        vehicles.extend(vehicle_info_tbl.count);
      
        for i in vehicle_info_tbl.first .. vehicle_info_tbl.last
        loop
          
          vehicles(i) := vehicle_info_tbl(i).get_vehicle();
           
        end loop;
      
      end if; 
  
    end if;

    return vehicles;
    
  end;

end vehicle_manager;
/

prompt Done.
