import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

public class Odometer
    extends AbstractSQLData
{
    public static final String ORACLE_OBJECT_NAME = "ODOMETER_OBJ_T";

    private int odometerId;
    private int mileage;

    public Odometer()
    {
        setSQLTypeName(ORACLE_OBJECT_NAME);
    }

    public int getMileage()
    {
        return mileage;
    }

    public void readSQL(SQLInput sqlInput, String sqlTypeName)
        throws SQLException
    {
        setSQLTypeName(sqlTypeName);

        odometerId = sqlInput.readInt();
        mileage = sqlInput.readInt();
    }

    public void writeSQL(SQLOutput sqlOutput)
        throws SQLException
    {
        sqlOutput.writeInt(odometerId);
        sqlOutput.writeInt(mileage);
    } 

    public String toString()
    {
        return Integer.toString(mileage) + " miles";
    }
}
