import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

public class OffRoadVehicle
    extends PassengerVehicle
{
    public static final String ORACLE_OBJECT_NAME = "OFFROAD_VEHICLE_OBJ_T";

    protected FuelTank auxillaryFuelTank;

    public OffRoadVehicle()
    {
        setSQLTypeName(ORACLE_OBJECT_NAME);
    }

    protected void readSQL(SQLInput sqlInput)
        throws SQLException
    {
        super.readSQL(sqlInput);

        auxillaryFuelTank = (FuelTank)sqlInput.readObject();
    }

    public void readSQL(SQLInput sqlInput, String sqlTypeName)
        throws SQLException
    {
        setSQLTypeName(sqlTypeName);
        readSQL(sqlInput);
    }

    public void writeSQL(SQLOutput sqlOutput)
        throws SQLException
    {
        super.writeSQL(sqlOutput);
        sqlOutput.writeObject(auxillaryFuelTank);
    } 

    protected String attributeString()
    {
        StringBuffer retVal = new StringBuffer(128);

        retVal.append(super.attributeString());
        retVal.append("  OffRoad Vehicle attributes:\n");
        retVal.append("    auxillary fuel tank: ").append(auxillaryFuelTank).append("\n");

        return retVal.toString();
    }

    public String toString()
    {
        StringBuffer retVal = new StringBuffer(128);

        retVal.append("OffRoadVehicle:\n");
        retVal.append(attributeString());

        return retVal.toString();
    }
}
