import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

public abstract class Vehicle
    extends AbstractSQLData
{
    public static final String ORACLE_ARRAY_NAME = "VEHICLE_TBL_T";

    protected int vehicleId;
    protected String make;
    protected String model;
    protected int range;
    protected FuelTank fuelTank;
    protected Odometer odometer;
    protected Odometer tripOdometer;

    protected void readSQL(SQLInput sqlInput)
        throws SQLException
    {
        vehicleId = sqlInput.readInt();
        make = sqlInput.readString();
        model = sqlInput.readString();
        range = sqlInput.readInt();
        fuelTank = (FuelTank)sqlInput.readObject();
        odometer = (Odometer)sqlInput.readObject();
        tripOdometer = (Odometer)sqlInput.readObject();
    }

    public void writeSQL(SQLOutput sqlOutput)
        throws SQLException
    {
        sqlOutput.writeInt(vehicleId);
        sqlOutput.writeString(make);
        sqlOutput.writeString(model);
        sqlOutput.writeInt(range);
        sqlOutput.writeObject(fuelTank);
        sqlOutput.writeObject(odometer);
        sqlOutput.writeObject(tripOdometer);
    }

    protected String attributeString()
    {
        StringBuffer retVal = new StringBuffer(128);

        retVal.append("  Vehicle attributes:\n");
        retVal.append("    vehicleID:      ").append(vehicleId).append("\n");
        retVal.append("    make:           ").append(make).append("\n");
        retVal.append("    model:          ").append(model).append("\n");
        retVal.append("    range:          ").append(range).append(" miles\n");
        retVal.append("    fuel tank:      ").append(fuelTank).append("\n");
        retVal.append("    odometer:       ").append(odometer).append("\n");
        retVal.append("    trip odometer:  ").append(tripOdometer).append("\n");

        return retVal.toString();
    }
}
